Bug 177861 - libtool will always pick a .la over a .so lib, even if wrong arch.
libtool will always pick a .la over a .so lib, even if wrong arch.
Product: Fedora
Classification: Fedora
Component: libtool (Show other bugs)
x86_64 Linux
medium Severity medium
: ---
: ---
Assigned To: Karsten Hopp
Depends On:
  Show dependency treegraph
Reported: 2006-01-15 15:06 EST by David Juran
Modified: 2007-11-30 17:11 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2006-01-16 06:03:46 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description David Juran 2006-01-15 15:06:39 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686 (x86_64); en-US; rv:1.7.12) Gecko/20050922 Fedora/1.0.7-1.1.fc4 Firefox/1.0.7

Description of problem:
It seems like libtool, while linking, as soon as it finds a .la file it will stop looking further even if the .la happens to refer to the wrong architecture. Therefor it will miss that there actually is a .so installed for the correct architecture. 

More specifically, I have popt-1.10.1-22.i386 and popt-1.10.2-11.x86_64 installed. In the x86_64 version which is newer, libpopt.la has been removed, but the i386 version still contains the .la file. Now while building gnome-vfs2-2.13.3-3 I get the following problem:

/usr/bin/libtool --tag=CC --mode=link gcc  -O2 -g -pipe -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -m64 -mtune=nocona  -L/usr/kerberos/lib -L/usr/kerberos/lib64   -o gnomevfs-cat  gnomevfs-cat.o ../libgnomevfs/libgnomevfs-2.la -pthread -lbonobo-activation -lgconf-2 -lORBit-2 -lm -lgmodule-2.0 -ldl -lgthread-2.0 -lglib-2.0   -lpopt  -lutil -lrt -lrt 

which renders

gcc -O2 -g -pipe -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -m64 -mtune=nocona -o .libs/gnomevfs-cat gnomevfs-cat.o -pthread  -L/usr/kerberos/lib -L/usr/kerberos/lib64 ../libgnomevfs/.libs/libgnomevfs-2.so -lgobject-2.0 -lbonobo-2 -lxml2 -lpthread -lssl -lcrypto -lgssapi_krb5 -lkrb5 -lcom_err -lk5crypto -lz -L/usr/lib -lavahi-glib -lavahi-common -lavahi-client -lresolv -lbonobo-activation -lgconf-2 -lORBit-2 -lm -lgmodule-2.0 -ldl -lgthread-2.0 -lglib-2.0 /usr/lib/libpopt.so -lutil -lrt -Wl,--rpath -Wl,/usr/lib

Do note how (the 32 bit) /usr/lib/libpopt.so is specifically pointed out on the gcc command line. The proper thing of course would have been to instead refer to /usr/lib64/libpopt.so  

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
1. install popt-1.10.1-22.i386 and popt-1.10.2-11.x86_64
2. build gnome-vfs2-2.13.3-3


Additional info:
Comment 1 Karsten Hopp 2006-01-16 06:03:46 EST
Do you have a smaller testcase that I can use without have to compile the whole
FC-5 gnome stuff on FC-4 ?

Btw: This usually isn't a bug in the libtool package, in the most cases when
such a problem occurs the tarball of your package contains old copies of libtool
You need to update them in order to get multilib builds fixed.

Please reopen when you have a smaller testcase without having to compile avahi,
mono, libdaemon, rpm, .... whatever

Note You need to log in before you can comment on or make changes to this bug.